/*
Copyright 2026 Seekra

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import { processArtifact } from './artifact.js';

const runPlugin = async function runPlugin (plugin) {
    const result = plugin();
    if (result instanceof Promise) return await result;
    else return result;
};

export const processPlugin = async function processPlugin (plugin, options) {
    const { artifacts } = await runPlugin(plugin);
    for (const artifact of artifacts) await processArtifact(artifact, options);
};